#define MAP_TIMED 1
#define MAP_TRIGGERED 2
#define MAP_CONTINUOUS 3
#define MAP_PLACED 4
#define ARMY_TIMED 5
#define ARMY_TRIGGERED 6
#define ARMY_CONTINUOUS 7
#define OBJECT_TRIGGERED_EVENT 8
#define OBJECT_TIMED_EVENT 9
#define OBJECT_CONTINUOUS_EVENT 10
#define OBJECT_STD_ATTACKED_EVENT 11
#define OBJECT_STD_CAPTURED_EVENT 12
#define OBJECT_STD_VICTORIOUS_EVENT 13
#define OBJECT_STD_ENTERED_EVENT 14
#define OBJECT_STD_ENCOUNTERED_EVENT 15
#define OBJECT_STD_DEFEATED_EVENT 16
#define OBJECT_STD_TRIGGERED_SCRIPT 17
#define OBJECT_STD_QUESTREQUEST_SCRIPT 18
#define OBJECT_STD_COMPLETEON_SCRIPT 19
#define PLACEDEVENT_ACTION 20
#define BOMB_PLACEHOLDER 21
#define ARMY 9
#define GARRIZON 32
#define PRIZON 56
#define SHIPYARD 81
#define BOMBA 23
#define PLACEDEVENT 25
#define DWELLING 21
#define GATE 57
#define QUEST 58
#define SEER 77
#define PANDORA 52
#define LIGHTHOUSE 38
#define GATEWAY_1 33
#define GATEWAY_2 90
#define GATEWAY_3 91
#define RANDOM_DWELLING 61
#define MINE 44
#define ABANDONED_MINE 0
#define MATERIAL_GENERATOR_1 73
#define MATERIAL_GENERATOR_2 102
#define MATERIAL_GENERATOR_3 103
#define TOWN 95
#define CARRYOVER_HERO 13
#define RANDOM_STACK_1 64
#define RANDOM_STACK_2 66
#define RANDOM_TOWN 72
#define RANDOM_CONSERVATORY 62
#define HERO 500
#define WANDER_UNDEFINED 1
#define WANDER_GUARD 2
#define WANDER_RUN 3
#define B_RED 1
#define B_BLUE 2
#define B_GREEN 4
#define B_ORANGE 8
#define B_PURPLE 16
#define B_TEAL 32
#define B_NO_ONE 64
#define P_THIS_OWNER 0
#define P_CURRENT 1
#define P_OPPOSITE 2
#define P_RED 3
#define P_BLUE 4
#define P_GREEN 5
#define P_ORANGE 6
#define P_PURPLE 7
#define P_TEAL 8
#define S_RED 0
#define S_BLUE 1
#define S_GREEN 2
#define S_ORANGE 3
#define S_PURPLE 4
#define S_TEAL 5
#define S_NO_ONE 6
#define HUMAN 1
#define AI 2
#define THIS_ARMY 0
#define FIRST_HERO_IN_THIS_ARMY 1
#define FIRST_HERO_IN_GARRISON 2
#define ANY_HERO_IN_OPPOSING_ARMY 3
#define MOST_POWERFUL_HERO_IN_THIS_ARMY 4
#define MOST_POWERFUL_HERO_IN_GARRISON 5
#define MOST_POWERFUL_HERO_IN_OPPOSING_ARMY 6
#define LEAST_POWERFUL_HERO_IN_THIS_ARMY 7
#define LEAST_POWERFUL_HERO_IN_GARRISON 8
#define LEAST_POWERFUL_HERO_IN_OPPOSING_ARMY 9
#define SKILL_TACTICS 0
#define SKILL_COMBAT 1
#define SKILL_SCOUTING 2
#define SKILL_NOBILITY 3
#define SKILL_LIFE_MAGIC 4
#define SKILL_ORDER_MAGIC 5
#define SKILL_DEATH_MAGIC 6
#define SKILL_CHAOS_MAGIC 7
#define SKILL_NATURE_MAGIC 8
#define SKILL_OFFENSE 9
#define SKILL_DEFENSE 10
#define SKILL_LEADERSHIP 11
#define SKILL_MELEE 12
#define SKILL_ARCHERY 13
#define SKILL_MAGIC_RESISTANCE 14
#define SKILL_PATHFINDING 15
#define SKILL_SEAMANSHIP 16
#define SKILL_STEALTH 17
#define SKILL_ESTATES 18
#define SKILL_MINING 19
#define SKILL_DIPLOMACY 20
#define SKILL_HEALING 21
#define SKILL_SPIRITUALITY 22
#define SKILL_RESURRECTION 23
#define SKILL_ENCHANTMENT 24
#define SKILL_WIZARDRY 25
#define SKILL_CHARM 26
#define SKILL_OCCULTISM 27
#define SKILL_DEMONOLOGY 28
#define SKILL_NECROMANCY 29
#define SKILL_CONJURATION 30
#define SKILL_PYROMANCY 31
#define SKILL_SORCERY 32
#define SKILL_HERBALISM 33
#define SKILL_MEDITATION 34
#define SKILL_SUMMONING 35
#define BASIC 0
#define ADVANCED 1
#define EXPERT 2
#define MASTER 3
#define GRANDMASTER 4
#define KNIGHT 0
#define PRIEST 1
#define LORD 2
#define MAGE 3
#define DEATH_KNIGHT 4
#define NEROMANCER 5
#define THIEF 6
#define SORCERER 7
#define ARCHER 8
#define DRUID 9
#define BARBARIAN 10
#define RANDOM 11
#define FEMALE 0
#define MALE 1
#define RANDOM 2
#define UNTIL_NEXT_BATTLE 0
#define PERMANENT 1
#define AIR_ELEMENTAL 0
#define ANGEL 1
#define BALLISTA 2
#define BANDIT 3
#define BEHEMOTH 4
#define EVIL_EYE 5
#define BLACK_DRAGON 6
#define BONE_DRAGON 7
#define CENTAUR 8
#define CERBERUS 9
#define CHAMPION 10
#define CROSSBOWMAN 11
#define CRUSADER 12
#define CYCLOPS 13
#define VENOM_SPAWN 14
#define DEVIL 15
#define DRAGON_GOLEM 16
#define DWARF 17
#define EARTH_ELEMENTAL 18
#define EFREET 19
#define ELF 20
#define FAERIE_DRAGON 21
#define FIRE_ELEMENTAL 22
#define GARGOYLE 23
#define GENIE 24
#define GHOST 25
#define BERSERKER 26
#define GOLD_GOLEM 27
#define GRIFFIN 28
#define HALFLING 29
#define HARPY 30
#define HYDRA 31
#define ICE_DEMON 32
#define IMP 33
#define LEPRECHAUN 34
#define MAGE 35
#define MANTIS 36
#define MEDUSA 37
#define MERMAIDS 38
#define MINOTAUR 39
#define MONK 40
#define MUMMY 41
#define NAGA 42
#define NIGHTMARE 43
#define NOMAD 44
#define OGRE_MAGE 45
#define ORC 46
#define PEASANT 47
#define PHOENIX 48
#define PIKEMAN 49
#define PIRATE 50
#define SATYR 51
#define SEA_MONSTERS 52
#define SKELETON 53
#define SQUIRE 54
#define SPRITE 55
#define THUNDERBIRD 56
#define TITAN 57
#define TROGLODITE 58
#define TROLL 59
#define UNICORN 60
#define VAMPIRE 61
#define WATER_ELEMENTAL 62
#define WHITE_TIGER 63
#define WOLF 64
#define ZOMBIE 65
#define WASPWORT 66
#define GOBLIN_KNIGHT 67
#define EVIL_SORCERESS 68
#define GARGANTUAN 69
#define DARK_CHAMPION 70
#define CATAPULT 71
#define FRENZIED_GNASHER 72
#define MEGA_DRAGON 73
#define ANIMATE_DEAD 2
#define ANTI_MAGIC 3
#define ARMAGEDDON 4
#define BANISH 5
#define BERSERK 6
#define BIND_WOUND 8
#define BLESS 10
#define BLIND 11
#define BLOOD_FRENZY 12
#define BLOODLUST 13
#define SPARKS 14
#define CANCELLATION 15
#define HEAVENLY_SHIELD 16
#define CHAIN_LIGHTNING 17
#define PHANTOM_IMAGE 18
#define CLOUD_OF_CONFUSION 19
#define CONFUSION 21
#define COWARDICE 22
#define CURSE 23
#define DEATH_CALL 24
#define DISINTEGRATE 26
#define DISPEL 27
#define DISPLACEMENT 28
#define CELESTIAL_ARMOR 29
#define DIVINE_INTERVENTION 30
#define DEFENDER 31
#define HOLY_SHOUT 32
#define DRAGON_STRENGTH 33
#define UNHOLY_SONG 34
#define EXCORTISM 35
#define AURA_OF_FEAR 36
#define FIRE_BOLT 39
#define FIRE_RING 41
#define FIREBALL 43
#define FIRE_AURA 44
#define FIRST_STRIKE 45
#define FLIGHT 46
#define FORGETFULNESS 47
#define FORTUNE 48
#define GIANT_STRENGTH 51
#define GUARDIAN_ANGEL 53
#define HAND_OF_DEATH 54
#define HASTE 55
#define HEAL 56
#define SPIRITUAL_ARMOR 58
#define RETRIBUTION 59
#define HOLY_WORD 61
#define HYPNOTIZE 62
#define ICE_BOLT 63
#define CREATE_ILLUSION 64
#define IMPLOSION 65
#define INFERNO 66
#define LIFE_DRAIN 68
#define LIGHTNING 69
#define MAGIC_ARROW 71
#define MAGIC_FIST 72
#define MAGIC_LEECH 73
#define MAGIC_MIRROR 74
#define MANA_FLARE 77
#define MARTYR 79
#define MASS_BLESS 80
#define MASS_CANCELATION 81
#define MASS_CURSE 82
#define MASS_DISPEL 83
#define MASS_EXORTISM 84
#define MASS_FIRST_STRIKE 85
#define MASS_FORTUNE 86
#define MASS_SPEED 87
#define MASS_HEALING 88
#define MASS_MISFORTUNE 89
#define MASS_PRECISION 90
#define MASS_CHAOS_WARD 91
#define MASS_DEATH_WARD 92
#define MASS_NATURE_WARD 93
#define MASS_ORDER_WARD 94
#define MASS_SLAYER 95
#define MASS_SLOW 96
#define MASS_SNAKE_STRIKE 97
#define MASS_SORROW 98
#define MASS_FERVOR 99
#define MASS_WEAKNESS 100
#define MIRE 101
#define MISFORTUNE 102
#define SPEED 104
#define SLOW 105
#define PAIN_MIRROR 106
#define PATHFINDING 108
#define BLUR 109
#define PLAGUE 110
#define POISON 111
#define POWER_DRAIN 113
#define PRAYER 114
#define PRECISION 115
#define CHAOS_WARD 117
#define DEATH_WARD 118
#define NATURE_WARD 120
#define ORDER_WARD 121
#define QUICKSAND 123
#define RAISE_GHOST 124
#define RAISE_SCELETONS 125
#define RAISE_VAMPIRES 126
#define MASS_BLUR 127
#define DISRUPTING_RAY 128
#define CAT_REFLEXES 130
#define REGENERATION 131
#define NECROMANCY_WARD 135
#define SACRIFICE 136
#define SANCTUARY 137
#define SLAYER 140
#define FATIGUE 141
#define SNAKE_STRIKE 143
#define SONG_OF_PEACE 144
#define SORROW 145
#define SPELL_SHACKLE 147
#define MIRTH 148
#define STEAL_ALL_ENCHANTMENTS 149
#define STEAL_ENCHANTMENT 150
#define STONESKIN 151
#define SUMMON_ELF 155
#define SUMMON_WHITE_TIGER 156
#define SUMMON_AIR_ELEMENTAL 157
#define SUMMON_SHIP 158
#define SUMMON_EARTH_ELEMENTAL 163
#define SUMMON_FAERIE_DRAGON 164
#define SUMMON_FIRE_ELEMENTAL 165
#define SUMMON_GRIFFIN 166
#define SUMMON_LEPRECHAUN 169
#define SUMMON_MANTIS 170
#define SUMMON_PHOENIX 171
#define SUMMON_SATIR 172
#define SUMMON_SPRITE 173
#define WASP_SWARM 174
#define SUMMON_UNICORN 175
#define SUMMON_WATER_ELEMENTAL 176
#define SUMMON_WOLF 177
#define TELEPORT 178
#define TERRAIN_WALK 179
#define TOWN_GATE 181
#define VAMPIRIC_TOUCH 182
#define VISIONS 183
#define WEAKNESS 185
#define SUMMON_WASPWORT 187
#define TRUE  f_True()
#define FALSE f_False()
#define YES   1
#define NO    0
#define BOMB  char